//This is written to go onto an ATTiny85.  If using an Arduino, change pin references. Also must change back to using the Servo library
//as Servo8Bit wont work.

//ATTiny85 Pinouts:
//                      ________
//  Reset              |1      8|  VCC
//  Pin 3(analog in 3) |2      7|  Pin 2 (analog in 1)
//  Pin 4(analog in 2) |3      6|  Pin 1 (PWM)
//  GND                |4      5|  Pin 0 (PWM)
//                      --------
//
//

#include "Servo8Bit.h"


Servo8Bit myservo;  //create a servo object.
                    //a maximum of five servo objects can be created
int statusLED = 0;    //shows as Pin 0 on ATTiny (pin 5 on board)
int pos = 0;    // variable to store the servo position 
//int foscamIRpin = A0;  //when IR is on, pin is high 1.5v. Else LOW 0v
int foscamIRpin = 3;  // shows as Pin 3(analog in 3) - labelled pin #3 on ATTiny85 board layout - when IR is on, pin is high 1.5v. Else LOW 0v
int state = 1;
int doneOnce = 0;
int CNCoff = 0;
int blinkCount = 0;


void setup() 
{ 

  myservo.attach(1,544,2200);  //shows as Pin 1 on ATTiny (pin 6 on board)  

  //Serial.begin (9600);
  //Serial.print("Started... running..."); Serial.println();
  pinMode(foscamIRpin, INPUT);
  pinMode(statusLED, OUTPUT);
  //get the starting state of the IR LEDs
  //if (analogRead(foscamIRpin) < 1) { startState = 0;} else {startState = 1;};
  //Serial.print("StartState: "); Serial.print(startState);    
  //Serial.println();
  
  
  //send servo to start position
  myservo.write(0);       

} 
 
 
void loop() 
{ 
   
  //Stop button clicked - IR goes off - trigger CNC Stop - but only if it hasn't alread been triggered
  //startState of 0 means IRs where already off - dont want to trigger keyboard stop
  //startState of 1 means IRs are on at start - good this is what we want.
  if (analogRead(foscamIRpin) < 1 && CNCoff == 0)
  {
   //IR LEDs are off

    hitKey(2);
    digitalWrite(statusLED, HIGH);   // turn the LED on (HIGH is the voltage level)
    blinkCount ++;
    CNCoff = 1;
    doneOnce = 0;
    //Serial.print("Stop clicked - IR LEDs off ");  Serial.println();
    delay(500);
    digitalWrite(statusLED, LOW);   // turn the LED of
    

  }
    //this is to catch when the IR LED have been reset (switched back on).  It will reset the system for the next round of cutting.
    //will look for a way in the web form to have it automatically reset the IR LEDs after a triggered shutdown.
    else if (analogRead(foscamIRpin) > 50 && doneOnce == 0)
  {
    //IR LEDs are on
    //Serial.print("Start clicked - IR LEDs on ");  Serial.println();
    CNCoff = 0;
    doneOnce = 1;
  }
  //Serial.print("IRVoltage: "); Serial.print(analogRead(foscamIRpin));    
  //Serial.print("  CNCoff: "); Serial.print(CNCoff);  
  //Serial.print("  DoneOnce: "); Serial.print(doneOnce);  
  //Serial.println(); 
  delay(100);
  //blink(blinkCount);
}


void hitKey(int spd)
{
  //CNCoff = 1;
  //Serial.print("CNC Triggered to shut off.  "); 
  //Serial.println();
  
   for(pos = 0; pos < 60; pos += 1)  // goes from 0 degrees to 180 degrees 
  {                                  // in steps of 1 degree 
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    
    //Serial.println (myservo.read());
    delay(spd);             // waits 15ms for the servo to reach the position 
  } 
  for(pos = 60; pos>=1; pos-=1)     // goes from 180 degrees to 0 degrees 
  {                                
    myservo.write(pos);              // tell servo to go to position in variable 'pos' 
    //Serial.println (myservo.read());
    delay(spd);                       // waits 15ms for the servo to reach the position 
    
  }  
  
  delay(100);

}

/*
void blink(int cnt)
{
  int i;
  if (cnt > 0)
  {
    for (i = 0; i<=cnt; i++)
    {
      digitalWrite(statusLED, HIGH);
      delay(10);
      digitalWrite(statusLED, LOW);
      delay(100);
    }
  }
}
*/

